'*********************************  QB.BI  ********************************
'                                                       
'JRD NOTE:
'Many sample programs use "QB.BI" as an $INCLUDE file. Instead of editing
'each one, I decided to make QB.BI my own
'4/19/94
'
'One User Defined TYPE for -both- CALL INTERRUPT and CALL INTERRUPTX
'
'The only difference is in the DECLARE, both use RegType as TYPE
'Be sure to change "RegTypeX" to "RegType" in the INTERRUPTX call.
'August 17, 1993
'
'QuickBASIC can use 10 of the 14 Registers (Built-in integer variables)

TYPE RegType
	 ax        AS INTEGER      'Accumulator       Register
	 bx        AS INTEGER      'Base                 "
	 cx        AS INTEGER      'Count                "
	 dx        AS INTEGER      'Data                 "
	 bp        AS INTEGER      'Base Pointer         "
	 si        AS INTEGER      'Source Index         "
	 di        AS INTEGER      'Destination Index    "
	 flags     AS INTEGER      'Flags                "
	 ds        AS INTEGER      'Data Segment         " (CALL InterruptX)
	 es        AS INTEGER      'Extra Segment        " (CALL InterruptX)
END TYPE

'Key code numbers for KeyCode% Function
	CONST BACKSPACE = 8
	CONST DELETE = 21248
	CONST DOWNARROW = 20480
	CONST ENDKEY = 20224
	CONST ENTER = 13
	CONST ESCAPE = 27
	CONST HOME = 18176
	CONST INSERTKEY = 20992
	CONST LEFTARROW = 19200
	CONST RIGHTARROW = 19712
	CONST TABKEY = 9
	CONST UPARROW = 18432

'True/False Constants  
	CONST False = 0
	CONST True = -1         'NOT False is too general


'                 DECLARE statements for -3- CALL Interrupts
'                 -------------------------------------
'
'A software interrupt, loading -8- registers
'
DECLARE SUB INTERRUPT (IntNum AS INTEGER, InRegs AS RegType, OutRegs AS RegType)
'
'A software interrupt, loading segment registers, -10- registers
'
DECLARE SUB INTERRUPTX (IntNum AS INTEGER, InRegs AS RegType, OutRegs AS RegType)
'
'
'Call an Assembly routine at an absolute address.
'NOTE: If the routine called takes parameters, then they will have to
'      be added to this declare statement before the parameter given.
'
DECLARE SUB ABSOLUTE (address AS INTEGER)

